Upgrading Unity Project - es3postprocessor crash

Discussion and help for Easy Save 3
dalem12
Posts: 5
Joined: Mon Jan 17, 2022 11:19 pm

Upgrading Unity Project - es3postprocessor crash

Post by dalem12 »

Hi, I am having trouble with ES3 causing crashes.

I have recently updated Unity from 2019.4.31 to 2021.2.x (any of the 2021.2.x has the same issue).

Since then I have had constant crashes that seem to be caused by ES3 in the latest versions of Unity, before this everything was working fine.

I can't save or play the project without it crashing. Even deleting the ES3 asset from the project still causes it to crash; when I click anything, Unity will start loading and I get a ES3Postprocessor.OnWillSaveAssets, even when ES3 is not in the project.

When I delete the asset from the project and reimport it, I get a Script Updating Consent popup about the ES3Prefab.cs. If I click yes, the project has no errors but trying to save or play causes crashes. If I press no, I get this error:
Assets\Plugins\Easy Save 3\Scripts\ES3Prefab.cs(93,55): error CS0234: The type or namespace name 'PrefabStageUtility' does not exist in the namespace 'UnityEditor.Experimental.SceneManagement' (are you missing an assembly reference?)
Here is some screenshots of the errors https://imgur.com/a/tqMoIuA

I am not really sure what to do at this stage but currently the entire project is unusable. On the plus side, I use Unity Collab so I can go back to the version that was running on 2019.4.31, but I do need to update to the latest version of Unity. So I don't know if there is a better way to upgrade the project or maybe something happened when the project when it was opened in the newer editor.

Edit: Forgot to mention, I have already upgraded a project before this one and had no issues (From 2019.4.31 to 2021.2.8), it is just this project that is having these issues.

User avatar
Joel
Moodkie Staff
Posts: 4015
Joined: Wed Nov 07, 2012 10:32 pm

Re: Upgrading Unity Project - es3postprocessor crash

Post by Joel »

Hi there,

Assuming you're using the latest version of Easy Save, it looks like there's an error in Unity's script upgrader. It appears to have replaced UnityEditor.SceneManagement.PrefabStageUtility with UnityEditor.Experimental.SceneManagement.PrefabStageUtility, the latter of which doesn't exist in Unity 2021.2. I recommend reporting this to Unity.

Regarding the crashes you describe when you don't upgrade scripts, please could you tell me more? What errors do you get? When does it happen? What's in the log file?

All the best,
Joel
Joel @ Moodkie Interactive
Purchase Easy Save | Contact | Guides | Docs | Getting started

dalem12
Posts: 5
Joined: Mon Jan 17, 2022 11:19 pm

Re: Upgrading Unity Project - es3postprocessor crash

Post by dalem12 »

As far as I know I am, I have deleted the asset from my PC (where Unity downloads assets) and redownloaded it, imported it again and it makes no difference. The line UnityEditor.Experimental.SceneManagement.PrefabStageUtility is there when I import it from the asset store, its the script upgrader that removes the "Experimental" part.

The crashes happen when the scripts are upgraded (removing Experimental from that line). If that line is not changed, I just get an error (shown in the imgur link). I also tried altering the line manually and same issues. I have also deleted the asset from the project and imported the asset from the project that upgraded Unity versions and is working correctly, but it doesn't work in this project, same issue. These crashes happen constantly, sometimes it happens just trying to open the project, if I get past that it will happen if I try to play the game or save the project, every time.

Here is a link to the crash log: https://drive.google.com/file/d/1HERTMp ... sp=sharing

User avatar
Joel
Moodkie Staff
Posts: 4015
Joined: Wed Nov 07, 2012 10:32 pm

Re: Upgrading Unity Project - es3postprocessor crash

Post by Joel »

Hi there,

Please could you send me the crash report located in C:/Users/dalem/AppData/Local/Temp/Unity/Editor/Crashes as mentioned at the end of the log file.

All the best,
Joel
Joel @ Moodkie Interactive
Purchase Easy Save | Contact | Guides | Docs | Getting started

dalem12
Posts: 5
Joined: Mon Jan 17, 2022 11:19 pm

Re: Upgrading Unity Project - es3postprocessor crash

Post by dalem12 »

Sorry for the delay!

Here is the crash report: https://drive.google.com/file/d/1j2XHLs ... sp=sharing

User avatar
Joel
Moodkie Staff
Posts: 4015
Joined: Wed Nov 07, 2012 10:32 pm

Re: Upgrading Unity Project - es3postprocessor crash

Post by Joel »

Hi there,

Are you sure you’ve posted the correct file? This still appears to be the same Editor.log file.

All the best,
Joel
Joel @ Moodkie Interactive
Purchase Easy Save | Contact | Guides | Docs | Getting started

dalem12
Posts: 5
Joined: Mon Jan 17, 2022 11:19 pm

Re: Upgrading Unity Project - es3postprocessor crash

Post by dalem12 »

Yes it is, I deleted the old one and reuploaded a new one from the location you told me. They just have the same name.

User avatar
Joel
Moodkie Staff
Posts: 4015
Joined: Wed Nov 07, 2012 10:32 pm

Re: Upgrading Unity Project - es3postprocessor crash

Post by Joel »

Hi there,

I see. It looks like Unity is failing to output any error which indicates an internal issue, which always means a bug at Unity's end. This would make sense as previous upgrades have worked fine, so indicates an issue with your version of Unity 2021.2.

Please could you replicate your issue in a new project with a basic scene and private message it to me with instructions so that I can see what is happening for myself? Hopefully then I'll at least be able to see what part of our API is triggering the bug so that I can send a bug report.

All the best,
Joel
Joel @ Moodkie Interactive
Purchase Easy Save | Contact | Guides | Docs | Getting started

dalem12
Posts: 5
Joined: Mon Jan 17, 2022 11:19 pm

Re: Upgrading Unity Project - es3postprocessor crash

Post by dalem12 »

Just an update, its the ES3 Manager prefab (https://imgur.com/a/tqMoIuA). Deleting it from the scene solved all issues. Project updated correctly and haven't had any more crashes. I tried adding it back to the project (Tools > Easy Save 3 > Add Manager to Scene) and the same "Unexpected Mark Stack Overflow" error happens and the project crashes. I also tried in my other project I updated (it never had the prefab in the project), exactly the same issue, same crash error when trying to add the prefab.

In saying that, I created a new project in 2021.2.8, imported the ES3 asset (clicked yes for the script updater), created the ES3 Manager prefab and no problems, no issues what so ever.

So I have no idea what's happening in my projects and why this causes such a massive issue. On the plus side the issue is fixed on my end as I don't need the prefab in my games. But I couldn't recreate it in a new project. I am happy to help so let me know if you want me to try anything else to try to recreate this issue :)

Thanks for trying to help me out though :)

User avatar
Joel
Moodkie Staff
Posts: 4015
Joined: Wed Nov 07, 2012 10:32 pm

Re: Upgrading Unity Project - es3postprocessor crash

Post by Joel »

Hi there,

Unfortunately without a basic project to replicate the issue, it wouldn’t be possible for me to understand what is happening as I would need to understand the entire logic of your project before being able to isolate the issue.

However, if you do have any other information which may be able to help (like the stack trace of the stack overflow exception you mentioned, that might help just in case anyone else encounters this issue.

All the best,
Joel
Joel @ Moodkie Interactive
Purchase Easy Save | Contact | Guides | Docs | Getting started

Post Reply